<?php
if (!defined('_PS_VERSION_')) {
    exit;
}

class PFIX_INFO_BAR extends Module
{
    public function enable($force_all = false)
{
    return parent::enable($force_all) &&
        $this->registerHook('displayTop') &&
        $this->registerHook('displayFooter') &&
        $this->registerHook('displayLeftColumn') &&
        $this->registerHook('displayRightColumn');
}
	protected $config_form = false;

    public function __construct()
    {
        $this->name = 'pfix_info_bar';
        $this->tab = 'pricing_promotion';
        $this->version = '1.0.0';
        $this->author = 'TOMASZ ADAMCZYK PRESTAFIX.PL';
        $this->need_instance = 0;
        $this->bootstrap = true;

        parent::__construct();

        $this->displayName = $this->l('PFIX Info Bar');
        $this->description = $this->l('Dodaj dynamiczny pasek informacyjny do swojego sklepu! Wyświetlaj ważne wiadomości, promocje lub alerty w dowolnym miejscu: na górze, dole lub po bokach strony.');

        $this->ps_versions_compliancy = array('min' => '1.7', 'max' => _PS_VERSION_);
    }

    public function install()
    {
        return parent::install() &&
            Configuration::updateValue('PFIX_INFO_BAR_TEXT', 'Domyślny tekst paska informacyjnego') &&
            $this->registerHook('displayFooter') &&
            $this->registerHook('displayLeftColumn') &&
            $this->registerHook('displayRightColumn') &&
            $this->registerHook('header') &&
            $this->registerHook('displayTop');
    }

    public function uninstall()
    {
        return parent::uninstall() &&
            Configuration::deleteByName('PFIX_INFO_BAR_TEXT');
    }

    public function getContent()
    {
        if (Tools::isSubmit('submitPFIX_INFO_BARModule')) {
            $this->postProcess();
        }

        return $this->renderForm();
    }

    protected function renderForm()
    {
        $helper = new HelperForm();
        $helper->show_toolbar = false;
        $helper->module = $this;
        $helper->identifier = $this->identifier;
        $helper->submit_action = 'submitPFIX_INFO_BARModule';
        $helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false)
            .'&configure='.$this->name;
        $helper->token = Tools::getAdminTokenLite('AdminModules');

        $helper->tpl_vars = array(
            'fields_value' => $this->getConfigFormValues(),
            'languages' => $this->context->controller->getLanguages(),
            'id_language' => $this->context->language->id,
        );

        return $helper->generateForm(array($this->getConfigForm()));
    }

    protected function getConfigForm()
    {
        return array(
            'form' => array(
                'legend' => array(
                    'title' => $this->l('Ustawienia'),
                    'icon' => 'icon-cogs',
                ),
                'input' => array(
                    array(
                        'type' => 'textarea',
                        'label' => $this->l('Treść paska informacyjnego'),
                        'name' => 'PFIX_INFO_BAR_TEXT',
                        'cols' => 40,
                        'rows' => 4,
                        'desc' => $this->l('Wpisz treść, która będzie wyświetlana w pasku informacyjnym.'),
                    ),
                ),
                'submit' => array(
                    'title' => $this->l('Zapisz'),
                ),
            ),
        );
    }

    protected function getConfigFormValues()
    {
        return array(
            'PFIX_INFO_BAR_TEXT' => Configuration::get('PFIX_INFO_BAR_TEXT', 'Domyślny tekst paska informacyjnego'),
        );
    }

    protected function postProcess()
    {
        Configuration::updateValue('PFIX_INFO_BAR_TEXT', Tools::getValue('PFIX_INFO_BAR_TEXT'));
    }

    public function hookDisplayTop()
    {
        return $this->displayBar();
    }

    public function hookDisplayFooter()
    {
        return $this->displayBar();
    }

    public function hookDisplayLeftColumn()
    {
        return $this->displayBar();
    }

    public function hookDisplayRightColumn()
    {
        return $this->displayBar();
    }

      private function displayBar()
    {
        $this->context->smarty->assign([
            'infobar_message' => Configuration::get('PFIX_INFO_BAR_TEXT', 'Domyślny tekst paska informacyjnego')
        ]);

        return $this->display(__FILE__, 'views/templates/hook/infobar.tpl');
    }
    public function hookHeader()
{
    $this->context->controller->addCSS($this->_path.'views/css/infobar.css');
    $this->context->controller->addJS($this->_path.'views/js/infobar.js');
}
    
}
